<?php

namespace FiloBlu\Flow\Console\Command;

use Symfony\Component\Console\Command\Command;
use Symfony\Component\Console\Input\InputInterface;
use Symfony\Component\Console\Output\OutputInterface;
use Magento\Framework\App\ObjectManager;

/**
 * Class ProcessCommand
 * @package FiloBlu\Flow\Console\Command
 */
class ProcessCommand extends Command
{
    /**
     * @var \Magento\Framework\App\State
     */
    protected $_state;

    /**
     * ProcessCommand constructor.
     * @param \Magento\Framework\App\State $state
     */
    public function __construct(\Magento\Framework\App\State $state) {
        $this->_state = $state;
        parent::__construct();
    }

    /**
     *
     */
    protected function configure()
    {
        $this->setName('flow:process')->setDescription('Process data channels');
    }

    /**
     * @param InputInterface $input
     * @param OutputInterface $output
     * @return int|null|void
     */
    protected function execute(InputInterface $input, OutputInterface $output)
    {
        try {
            $this->_state->setAreaCode(\Magento\Framework\App\Area::AREA_ADMINHTML);
        } catch (\Exception $e) {

            $currentAreaCode = $this->_state->getAreaCode();
            $output->writeln("Areacode was already set to {$currentAreaCode}");
        }
        /** @var \FiloBlu\Flow\Cron\Fetch $cronModel */
        $cronModel = ObjectManager::getInstance()->create(\FiloBlu\Flow\Cron\Fetch::class);
        $cronModel->process();
        $output->writeln('<info>Process executed !</info>');
    }
}